human_arch	= ARMv8
build_arch	= arm64
header_arch	= arm64
defconfig	= defconfig
flavours	= boundary-20j
build_image	= Image
kernel_file	= arch/$(build_arch)/boot/Image
install_file	= vmlinux
no_dumpfile = true
disable_d_i	= true
full_build	= true
skipdbg		= false
uefi_signed     = false

vdso		= vdso_install

do_tools		= true
do_cloud_tools		= false
do_extras_package	= false
do_tools_usbip  = true
do_tools_acpidbg	= true
do_tools_cpupower = true
do_tools_perf   = true
do_tools_x86		= false
do_tools_hyperv		= false
do_tools_perf_jvmti = true
do_tools_bpftool = true

srcpkgname	= linux-boundary-20j
gcc		= gcc-11
do_dtbs		= true
do_zfs		= false
do_dkms_wireguard = false
skipretpoline	= true
do_libc_dev_package = false

# Flavour specific configuration.
dtb_files_boundary-20j	+= imx8mm-c2.dtb
dtb_files_boundary-20j	+= imx8mm-c2-mid.dtb
dtb_files_boundary-20j	+= imx8mm-dwe.dtb
dtb_files_boundary-20j	+= imx8mm-em.dtb
dtb_files_boundary-20j	+= imx8mm-geno.dtb
dtb_files_boundary-20j	+= imx8mm-hl8mm.dtb
dtb_files_boundary-20j	+= imx8mm-kea.dtb
dtb_files_boundary-20j	+= imx8mm-moo.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8_lite.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm-m4.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm_rev2.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm_rev2-m4.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm_rev2-tc358743.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm_som.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm_som-m4.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm_som-mcp2518fd.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm_som-mcp25625.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm_som-tc358743.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm_som-tg.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm_svt.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm_tab.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen8mm-tc358743.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen-r2.dtb
dtb_files_boundary-20j	+= imx8mm-nitrogen_smarc.dtb
dtb_files_boundary-20j	+= imx8mm-span.dtb
dtb_files_boundary-20j	+= imx8mn-nitrogen8mn.dtb
dtb_files_boundary-20j	+= imx8mn-nitrogen8mn_som.dtb
dtb_files_boundary-20j	+= imx8mn-nitrogen8mn_som-m4.dtb
dtb_files_boundary-20j	+= imx8mn-nitrogen8_nano.dtb
dtb_files_boundary-20j	+= imx8mn-nitrogen8_nano-m4.dtb
dtb_files_boundary-20j	+= imx8mn-nitrogen_smarc.dtb
dtb_files_boundary-20j	+= imx8mp-bm.dtb
dtb_files_boundary-20j	+= imx8mp-crs.dtb
dtb_files_boundary-20j	+= imx8mp-mmr.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp-basler3840-4200.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp-enc-ar.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp-enc-basler4200-ov5640.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp-enc.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp-enc-m4.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp-enc-tc358743.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp-m4.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp_r20-basler3840-4200.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp_r20.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp_r20-enc-ar.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp_r20-enc-basler4200-ov5640.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp_r20-enc.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp_r20-enc-m4.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp_r20-enc-tc358743.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp_r20-m4.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen8mp_vm.dtb
dtb_files_boundary-20j	+= imx8mp-nitrogen_smarc.dtb
dtb_files_boundary-20j	+= imx8mq-bio.dtb
dtb_files_boundary-20j	+= imx8mq-ds.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m-avt.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m-edp.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m-gbr.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m-m4.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m-mcp2518fd.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m-sch.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m_som-ags.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m_som-ags-m4.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m_som.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m_som-m4.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m_som-sd.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m-tc358743.dtb
dtb_files_boundary-20j	+= imx8mq-nitrogen8m-tc358840.dtb
dtb_files_boundary-20j	+= imx8mq-son.dtb
dtb_files_boundary-20j	+= imx8ulp-nitrogen-som.dtb
dtb_files_boundary-20j	+= imx8ulp-nitrogen-som-m33.dtb
dtb_files_boundary-20j	+= imx8ulp-tag.dtb
dtb_files_boundary-20j	+= imx8ulp-tag-m33.dtb

